(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: 3UHELNIK.PAS                                                   *)
(*  Obsah: par procedur a funkci pro ruzne operace s trojuhelniky          *)
(*         a ukazkovy program                                              *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 13.5.2010                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program trojuhelniky;

const dm=3; {na kolik desetinnych mist maji byt zaokrouhlena cisla na obrazovce}

type trojuhelnik = array[1..3] of record
                                  x,y:real; {souradnice vrcholu}
                                  oznaceni:char; {pismeno prirazene k vrcholu}
                                  end;

procedure ZadejTrojuhelnik(var ktery:trojuhelnik); {zadani trojuhelniku z klavesnice}
var i:byte;
Begin
writeln('Znaceni trojuhelniku:');
for i:=1 to 3 do begin
                 write('Zadej oznaceni ',i,'. vrcholu: ');
                 readln(ktery[i].oznaceni);
                 ktery[i].oznaceni:=upcase(ktery[i].oznaceni);
                 end;
writeln('Souradnice vrcholu (ve tvaru x mezera y, desetiny oddelujte teckou):');
for i:=1 to 3 do begin
                 write('Zadej vrchol ',ktery[i].oznaceni,': ');
                 readln(ktery[i].x,ktery[i].y);
                 end;
End;{zadejtrojuhelnik}

procedure VypisTrojuhelnik(ktery:trojuhelnik); {vypis trojuhelniku na obrazovku}
var i:byte;
Begin
writeln('Trojuhelnik ',ktery[1].oznaceni,ktery[2].oznaceni,ktery[3].oznaceni,':');
for i:=1 to 3 do writeln('Vrchol ',ktery[i].oznaceni,': x = ',ktery[i].x:0:dm,', y = ',ktery[i].y:0:dm);
End;{vypistrojuhelnik}

function JdeSestrojit(t:trojuhelnik):boolean;
Begin
jdesestrojit:=((t[1].x<>t[2].x)or(t[1].x<>t[3].x)) {Kdyz vrcholy trojuhelnika nelezi v primce primo nad sebou...}
     and ((t[1].y<>t[2].y)or(t[1].y<>t[3].y)) {...ani primo vedle sebe...}
     and ((t[3].y-t[1].y)/(t[3].x-t[1].x)<>(t[2].y-t[1].y)/(t[2].x-t[1].x)); {...ani na jakekoli jine primce,...}
End;{jdesestrojit}                                                         {...tak je trojuhelnik sestrojitelny.}

function DelkaStranyI(index:byte; kde:trojuhelnik):real; {vrati delku strany naproti indextemu vrcholu, index je 1..3}
var zacatek,konec:byte;
Begin
if (index<1)or(index>3)
  then delkastranyi:=0 {index je mimo mozny rozsah - chyba}
  else begin
       zacatek:=index+1; if zacatek>3 then dec(zacatek,3);
       konec:=index+2;   if konec>3 then dec(konec,3);
       delkastranyi:=sqrt(sqr(kde[zacatek].x-kde[konec].x)+sqr(kde[zacatek].y-kde[konec].y));
       end;
End;{delkastranyi}

function DelkaStrany(ktere:char; kde:trojuhelnik):real; {vrati delku strany naproti vrcholu s danym pismenem}
var i:byte;
Begin
i:=1;
ktere:=upcase(ktere);
while (i<=3)and(kde[i].oznaceni<>ktere) do inc(i);
if i>3 then delkastrany:=0 {prosli jsme vsechny vrcholy a zadny nemel tohle pismeno}
       else delkastrany:=delkastranyi(i,kde);
End;{delkastrany}

procedure NajdiStredyStran(ceho:trojuhelnik; var vysledky:trojuhelnik);
{najde stredy stran trojuhelniku predaneho prvnim parametrem a ulozi je jako trojuhelnik pres druhy parametr}
var i:byte;
    MaxPismeno:char;
Begin
{pripravime oznaceni noveho trojuhelnika:}
maxpismeno:='A'; {najdeme, ktery vrchol puvodniho trojuhelnika je v abecede nejdal:}
for i:=1 to 3 do if ceho[i].oznaceni>maxpismeno then maxpismeno:=ceho[i].oznaceni;
if maxpismeno>='X' then maxpismeno:='A' {uz bychom se nevesli do konce abecedy, tak se vratime na zacatek}
                   else inc(maxpismeno);
for i:=1 to 3 do begin {ulozime oznaceni novych vrcholu}
                 vysledky[i].oznaceni:=maxpismeno;
                 inc(maxpismeno);
                 end;
{vypocet stredu stran:}
for i:=1 to 3 do begin {souradnice stredu strany jsou aritmeticke prumery mezi souradnicemi vrcholu}
                 vysledky[i].x:=(ceho[i].x+ceho[(i mod 3)+1].x)/2;
                 vysledky[i].y:=(ceho[i].y+ceho[(i mod 3)+1].y)/2;
                 end;
End;{najdistredystran}

procedure NajdiTezisteTrojuhelnika(ktereho:trojuhelnik; var vysledekX,vysledekY:real);
{vypocita polohu teziste trojuhelnika, cili aritmeticky prumer souradnich vsech tri vrcholu}
Begin
vysledekx:=(ktereho[1].x+ktereho[2].x+ktereho[3].x)/3;
vysledeky:=(ktereho[1].y+ktereho[2].y+ktereho[3].y)/3;
End;{najditezistetrojuhelnika}

function ObvodTrojuhelnika(ktereho:trojuhelnik):real; {vraci obvod, cili soucet delek vsech tri stran}
Begin
obvodtrojuhelnika:=delkastranyi(1,ktereho)+delkastranyi(2,ktereho)+delkastranyi(3,ktereho);
End;{obvodtrojuhelnika}

function ObsahTrojuhelnika(ktereho:trojuhelnik):real; {vraci obsah, pocita ho pomoci Heronova vzorce}
var s:real;
Begin
s:=obvodtrojuhelnika(ktereho)/2;
obsahtrojuhelnika:=sqrt(s*(s-delkastranyi(1,ktereho))
                         *(s-delkastranyi(2,ktereho))
                         *(s-delkastranyi(3,ktereho)));
End;{obsahtrojuhelnika}

function JePravouhly(ktery:trojuhelnik):boolean; {zjisti, jestli je trojuhelnik pravouhly}
var strany:array[1..3] of real;
    pom:real;
    i:byte;
    serazeny:boolean;
Begin
{spocitame si delky stran:}
for i:=1 to 3 do strany[i]:=delkastranyi(i,ktery);
{seradime je od nejmensi do nejvetsi (nejvetsi by mohla byt prepona):}
 repeat {bubblesort pro serazeni tri hodnot je sice ponekud kanon na vrabce, ale funguje}
 serazeny:=true;
 for i:=1 to 2 do
  if strany[i]>strany[i+1] then begin {dve strany jsou ve spatnem poradi, prohodime je}
                                pom:=strany[i];
                                strany[i]:=strany[i+1];
                                strany[i+1]:=pom;
                                serazeny:=false;
                                end;
 until serazeny;
{a nakonec to nejdulezitejsi - zkontrolujeme, jestli plati Pythagorova veta
 (tedy alespon priblizne - pocitame s realnymi cisly):}
jepravouhly:=abs(sqr(strany[1])+sqr(strany[2])-sqr(strany[3]))<1E-10;
End;{jepravouhly}

procedure CekejNaEnter;
Begin
write('Stiskni Enter. ');
readln;
End;{cekejnaenter}

{-------------------------- ukazkovy program: --------------------------}

var t1,t2:trojuhelnik;
    pismeno:char;
    x,y:real;

BEGIN
writeln(' Program na pocitani s trojuhelniky');
writeln('====================================');
writeln('        (c) Mircosoft 2010');
writeln;

writeln('Nejdriv je potreba zadat trojuhelnik, se kterym budeme pracovat.');
ZadejTrojuhelnik(t1);

writeln('Zadany trojuhelnik vypada takhle:');
VypisTrojuhelnik(t1);

write('Kontrola sestrojitelnosti: ');
if not JdeSestrojit(t1)
  then writeln('chyba, zadane body lezi na jedne primce.')
  else begin
       writeln('v poradku, zadane body tvori trojuhelnik.');
       writeln;

       write('Vypocitame si delku jedne strany. Ktere? (zadej pismeno) ');
       readln(pismeno);
       write('Strana ',pismeno,' ');
       x:=delkastrany(pismeno,t1);
       if x=0 then writeln('se v zadanem trojuhelniku nenachazi.')
              else writeln('je dlouha ',x:0:dm,' jednotek.');
       cekejnaenter;
       writeln;

       writeln('Stredni pricky zadaneho trojuhelnika jsou:');
       NajdiStredyStran(t1,t2);
       VypisTrojuhelnik(t2);
       cekejnaenter;
       writeln;

       write('Teziste zadaneho trojuhelnika lezi v bode ');
       NajdiTezisteTrojuhelnika(t1,x,y);
       writeln('x = ',x:0:dm,', y = ',y:0:dm);
       cekejnaenter;
       writeln;

       writeln('Trojuhelnik ma obvod ',ObvodTrojuhelnika(t1):0:dm,' jednotek');
       writeln('a obsah ',ObsahTrojuhelnika(t1):0:dm,' jednotek ctverecnich.');
       cekejnaenter;
       writeln;

       write('Take o nem muzeme rici, ze ');
       if JePravouhly(t1) then write('je')
                          else write('neni');
       writeln(' pravouhly.');
       end;
writeln;
writeln('To je vsechno, pro ukonceni stiskni Enter.');
readln;
END.
